--[[
  ****************************************************************
	GLock - Resist Calculator
	Resist Calculation Algorithm
	
	Written by Ogdin of the Deathreaver Legion.  Shadow Moon
	Contact via posts at http://www.atlantic-orcs.org/

	****************************************************************]]

-----------------------------------------------------------------------------------------------------------
--This is the main function that handles resist calculation for your damage data
-----------------------------------------------------------------------------------------------------------
function GLOCK_ResistCalc()

--Correct for rounding error
	if (gmitigated>10 and gmitigated<=35) then gmitigated=25 end
	if (gmitigated>35 and gmitigated<=60) then gmitigated=50 end
	if (gmitigated>60 and gmitigated<=85) then gmitigated=75 end

	GLNewData=(gmitigated)/100;
	GLNewColor=GLOCK_cast_school;
	GLGraphicsFlag=1;

	for i=1,84 do GLData1[i]=GLData1[i+1] GLData2[i]=GLData2[i+1] end
	GLData1[85]=GLNewData;
	if GLNewColor==GLOCK_schools[1] then GLData2[85]=2 end
	if GLNewColor==GLOCK_schools[2] then GLData2[85]=4 end
	if GLNewColor==GLOCK_schools[3] then GLData2[85]=3 end
	if GLNewColor==GLOCK_schools[4] then GLData2[85]=5 end
	if GLNewColor==GLOCK_schools[5] then GLData2[85]=1 end
	
	if not MobResistDB[GLOCK_dbindex] then MobResistDB[GLOCK_dbindex]="0/0_0A0|0"; end

--EXTRACT DATABASE ENTRY
	a=MobResistDB[GLOCK_dbindex];
	gstart, gstop, GLOCK_DBMiti, GLOCK_DBHits, GLOCK_DBMiss, GLOCK_DBMinR, GLOCK_DBi =
			string.find(a,"(.+)/(.+)_(.+)A(.+)|(.+)")


	GLOCK_DBMiti=tonumber(GLOCK_DBMiti)		--Current Resist Approximation
	GLOCK_DBHits=tonumber(GLOCK_DBHits)		--#of spells that have hit
	GLOCK_DBMiss=tonumber(GLOCK_DBMiss)		--#of 100% resists
	GLOCK_DBMinR=tonumber(GLOCK_DBMinR)		--Minimum spell penetration that a partial resist has been observed at
	GLOCK_DBi=tonumber(GLOCK_DBi)			--Hit number for first partial resist to start learning

--------------------------------------------------------RESIST CALCULATION STARTS HERE------------------------------------------------
	
--IF SPELL TOTALLY RESISTED
	if gmitigated==100 then 
		--MISS INCREMENT and track average penetration value
		
		GLOCK_DBMiss=GLOCK_DBMiss+1;
		if GLOCK_cast_school==GLOCK_schools[1] then GLOCK_temp1=GLElemPrec*2 else GLOCK_temp1=0 end
		GLOCK_DBi=(GLOCK_DBi*(GLOCK_DBHits+GLOCK_DBMiss-1)+(GLhit-GLOCK_temp1))/(GLOCK_DBHits+GLOCK_DBMiss)


		if (GLOCK_cast_school==GLOCK_schools[3]) then    --100% resists are only relevant in frost calculations currently
			GLHITS=GLOCK_DBMiss+GLOCK_DBHits;
			GLOCK_DBMiti=100-((100-GLOCK_DBMiti)*(GLHITS-1)+(0-gpenetration)/GLOCK_levelMiss(GLOCK_Target_Level))/GLHITS
			GLOCK_DBMinR=GLOCK_DBMinR-(GLOCK_DBMinR-gpenetration*4)*GLOCK_factor
		end

		MobResistDB[GLOCK_dbindex]=string.format("%f/%d_%dA%f|%f",GLOCK_DBMiti,GLOCK_DBHits,GLOCK_DBMiss,GLOCK_DBMinR,GLOCK_DBi);
		if (GLOCK_Config["CHATCHANNEL"]) then
			if GLOCK_cast_school==GLOCK_schools[1] then GLOCK_temp1=GLElemPrec*2 else GLOCK_temp1=0 end
			SendAddonMessage("GLOCKRC",GLOCK_dbindex..",,"..tostring(100).."++"..gpenetration.."=="..(0).."__"..(GLhit-GLOCK_temp1),"RAID")
		end

		GLOCK_UpdateGUI()
		return; 
	end

	


--Hit increment
	GLOCK_DBHits=GLOCK_DBHits+1;

	

--GLOCK_factor adapts as you get closer to the target (i.e. more samples available)
	if (GLOCK_DBHits)>GLCUSPS[1] then GLOCK_factor=GLFACTORS[1] end
	if (GLOCK_DBHits)>GLCUSPS[2] then GLOCK_factor=GLFACTORS[2] end
	if (GLOCK_DBHits)>GLCUSPS[3] then GLOCK_factor=GLFACTORS[3] end
	if (GLOCK_DBHits)>GLCUSPS[4] then GLOCK_factor=GLFACTORS[4] end
	if (GLOCK_DBHits)>GLCUSPS[5] then GLOCK_factor=GLFACTORS[5] end
	if (GLOCK_DBHits)>GLCUSPS[6] then GLOCK_factor=GLFACTORS[6] end
	if (GLOCK_DBHits)>GLCUSPS[7] then GLOCK_factor=GLFACTORS[7] end
	if (GLOCK_DBHits)>GLCUSPS[8] then GLOCK_factor=GLFACTORS[8] end
	
--Track Average +hit% on this mob for this school (ignore elemental precision if school is arcane)
	if GLOCK_cast_school==GLOCK_schools[1] then GLOCK_temp1=GLElemPrec*2 else GLOCK_temp1=0 end
	GLOCK_DBi=(GLOCK_DBi*(GLOCK_DBHits+GLOCK_DBMiss-1)+(GLhit-GLOCK_temp1))/(GLOCK_DBHits+GLOCK_DBMiss)
--Track Average penetration on this mob for this school
	GLOCK_DBMinR=GLOCK_DBMinR-(GLOCK_DBMinR-gpenetration*4)*GLOCK_factor

--CALCULATE THE NEW RESIST VALUE
	if GLOCK_cast_school~=GLOCK_schools[3] then
		GLOCK_diff=(gmitigated+gpenetration-GLOCK_DBMiti)*GLOCK_factor;
		GLOCK_DBMiti=GLOCK_DBMiti + GLOCK_diff;
	end

--SPECIFIC CALCULATION FOR BINARY FROST SPELLS (this also works with partially resisted frost spells such as frost wand damage)
	if GLOCK_cast_school==GLOCK_schools[3] then
		GLHITS=GLOCK_DBMiss+GLOCK_DBHits;
		GLOCK_DBMiti=100-((100-GLOCK_DBMiti)*(GLHITS-1)+(100-gmitigated-gpenetration)/GLOCK_levelMiss(GLOCK_Target_Level))/GLHITS
	end

--------------------------------------------------------RESIST CALCULATION ENDS HERE------------------------------------------------

--STORE DATA
	MobResistDB[GLOCK_dbindex]=string.format("%f/%d_%dA%f|%f",GLOCK_DBMiti,GLOCK_DBHits,GLOCK_DBMiss,GLOCK_DBMinR,GLOCK_DBi);

--BROADCAST Data
	if GLOCK_Config["CHATCHANNEL"] then
		if GLOCK_cast_school==GLOCK_schools[1] then GLOCK_temp1=GLElemPrec*2 else GLOCK_temp1=0 end
		SendAddonMessage("GLOCKRC",GLOCK_dbindex..",,"..gmitigated.."++"..gpenetration.."=="..(0).."__"..(GLhit-GLOCK_temp1),"RAID")
	end

	GLOCK_UpdateGUI()
	

end


-----------------------------------------------------------------------------------------------------------
--Determines your hit chance on the target.  As per Tseric's post and assuming 99% max hit chance
-----------------------------------------------------------------------------------------------------------
function GLOCK_levelMiss(GLEVEL)

	TempMiss=99;
	if GLEVEL==UnitLevel("Player") then TempMiss=96;
	elseif GLEVEL==(UnitLevel("Player")+1) then TempMiss=95;
	elseif GLEVEL==(UnitLevel("Player")+2) then TempMiss=94; 
	elseif GLEVEL==(UnitLevel("Player")+3) then TempMiss=83;
	elseif GLEVEL==(UnitLevel("Player")+4) then TempMiss=72;
	elseif GLEVEL==(-1) then TempMiss=83;   --Made the assumption that bosses will be equated to level 63 mobs
	end

	TempMiss=TempMiss+GLhit;
	if TempMiss>99 then TempMiss=99 end

	--base resist value is 1%
	return TempMiss/100

end


-----------------------------------------------------------------------------------------------------------
--This function determines the school of magic on a total resist (it doesn't explicity say "for x fire damage", for example)
-----------------------------------------------------------------------------------------------------------
function GLOCK_DecipherSchool(a)

	GLOCK_cast_school=nil;

	for i=1,table.getn(GLOCK_Fire) do if string.find(a,GLOCK_Fire[i]) then GLOCK_cast_school=GLOCK_schools[2]; end end
	for i=1,table.getn(GLOCK_Shadow) do if string.find(a,GLOCK_Shadow[i]) then GLOCK_cast_school=GLOCK_schools[5]; end end
	for i=1,table.getn(GLOCK_Arcane) do if string.find(a,GLOCK_Arcane[i]) then GLOCK_cast_school=GLOCK_schools[1]; end end
	for i=1,table.getn(GLOCK_Nature) do if string.find(a,GLOCK_Nature[i]) then GLOCK_cast_school=GLOCK_schools[4]; end end
	for i=1,table.getn(GLOCK_Frost) do if string.find(a,GLOCK_Frost[i]) then GLOCK_cast_school=GLOCK_schools[3]; end end

--DETECT WAND SCHOOL
	if string.find(a,GLWANDACTION) then

		--Wand slot is 18
		GLTooltip:SetInventoryItem("Player", 18);
		itemName = GLTooltipTextLeft1:GetText();
		lines = GLTooltip:NumLines();		
			for i=2, lines do
				tmpText = getglobal("GLTooltipTextLeft"..i);
				tmpStr=tmpText:GetText()
				if (tmpStr) then
					if string.find(tmpStr,GL_WAND_TEXT[1]) then GLOCK_cast_school=GLOCK_schools[1]; end
					if string.find(tmpStr,GL_WAND_TEXT[2]) then GLOCK_cast_school=GLOCK_schools[2]; end
					if string.find(tmpStr,GL_WAND_TEXT[3]) then GLOCK_cast_school=GLOCK_schools[3]; end
					if string.find(tmpStr,GL_WAND_TEXT[4]) then GLOCK_cast_school=GLOCK_schools[4]; end
					if string.find(tmpStr,GL_WAND_TEXT[5]) then GLOCK_cast_school=GLOCK_schools[5]; end
				end
					
			end
	end
	
end
