--[[
  ****************************************************************
	GLock - Resist Calculator
	Multi-Player Link Processing Code
	
	Written by Ogdin of the Deathreaver Legion.  Shadow Moon
	Contact via posts at http://www.atlantic-orcs.org/


	****************************************************************]]



-----------------------------------------------------------------------------------------------------------
--Catch incoming data from other players and parse the string for processing
-----------------------------------------------------------------------------------------------------------
function GLOCK_chatHandle()
	if arg4==UnitName("Player") then return end
	if not string.find(arg1,"GLOCKRC") then return end



	--Set Activity Indicators Green	
	GMaxActivity:SetVertexColor(0,1,0);
	GMinActivity:SetVertexColor(0,1,0);

	tmpStr=arg2;
	
	--Parse it
	gstart, gstop, GLOCK_sync_dbindex, GLOCK_sync_gmitigated, GLOCK_sync_gpenetration, GLOCK_sync_DBi, GLOCK_sync_GLhit =
		string.find(tmpStr,"(.+)%,%,(.+)%+%+(.+)%=%=(.+)%_%_(.+)")

	if gstart==nil then return end;
	GLOCK_sync_gmitigated=tonumber(GLOCK_sync_gmitigated);
	GLOCK_sync_gpenetration=tonumber(GLOCK_sync_gpenetration)
	GLOCK_sync_DBi=tonumber(GLOCK_sync_DBi);
	GLOCK_sync_GLhit=tonumber(GLOCK_sync_GLhit);
	
	gstart, gstop, GLOCK_sync_Name, GLOCK_sync_Level, GLOCK_sync_school =
		string.find(GLOCK_sync_dbindex,"(.+)/(.+)/(.+)")
	GLOCK_sync_Level=tonumber(GLOCK_sync_Level);


	--There is some uncaught message that gets parsed wrong and I think it has to do with the mob being immune temporarily or something.. Not sure.
	--For now, just drop out if the data was bad
	if GLOCK_sync_gmitigated==nil then 
		if UnitName("Player")=="Ogdin" then DEFAULT_CHAT_FRAME:AddMessage(arg2) end
	return end


		--VERBOSE CHAT IN CONFIG PANNEL
		GLOCK_Config["VCHAT1"]=GLOCK_Config["VCHAT2"]
		GLOCK_Config["VCHAT2"]=GLOCK_Config["VCHAT3"]
		GLOCK_Config["VCHAT3"]=GLOCK_Config["VCHAT4"]
		--GLSpecial=string.find(date()," ")+1
		GLOCK_Config["VCHAT4"]=string.sub(date(),string.find(date()," ")+1)..">  "..arg4.." - "..GLOCK_sync_Name.." - "..GLOCK_sync_school.." - "..GLOCK_sync_gmitigated.."%".." @ -"..(GLOCK_sync_gpenetration*4).." pene, "..GLOCK_sync_GLhit.."% Hit"
	
		GLOCKVCHAT_Text1:SetText(GLOCK_Config["VCHAT1"])	
		GLOCKVCHAT_Text2:SetText(GLOCK_Config["VCHAT2"])
		GLOCKVCHAT_Text3:SetText(GLOCK_Config["VCHAT3"])
		GLOCKVCHAT_Text4:SetText(GLOCK_Config["VCHAT4"])


	if (GLOCK_Config["PVP"]==0 and string.find(GLOCK_sync_Name,"*")) then return end
	--Do Damage calculations
	GLOCK_ChatDmgParse()
	
	
end


-----------------------------------------------------------------------------------------------------------
--Incorporate the new data point from the link channel into your data for the mob
-----------------------------------------------------------------------------------------------------------
function GLOCK_ChatDmgParse()

		if not GLOCK_sync_dbindex then return end
		if not GLOCK_sync_gmitigated then return end
	
		if not MobResistDB[GLOCK_sync_dbindex] then MobResistDB[GLOCK_sync_dbindex]="0/0_0A0|0"; end

		a=MobResistDB[GLOCK_sync_dbindex];

		gstart, gstop, GLOCK_DBMiti, GLOCK_DBHits, GLOCK_DBMiss, GLOCK_DBMinR, GLOCK_DBi =
			string.find(a,"(.+)/(.+)_(.+)A(.+)|(.+)")

		GLOCK_DBMiti=tonumber(GLOCK_DBMiti)		--Current Resist Approximation
		GLOCK_DBHits=tonumber(GLOCK_DBHits)		--#of spells that have hit
		GLOCK_DBMiss=tonumber(GLOCK_DBMiss)		--#of 100% resists
		GLOCK_DBMinR=tonumber(GLOCK_DBMinR)		--Minimum spell penetration that a partial resist has been observed at
		GLOCK_DBi=tonumber(GLOCK_DBi)			--Hit number for first partial resist to start learning


	if GLOCK_sync_gmitigated==100 then 
		--Average Penetration, Average Hit%, Miss increment
		GLOCK_DBMiss=GLOCK_DBMiss+1;
		GLOCK_DBi=(GLOCK_DBi*(GLOCK_DBHits+GLOCK_DBMiss-1)+(GLOCK_sync_GLhit))/(GLOCK_DBHits+GLOCK_DBMiss)

		if GLOCK_sync_school==GLOCK_schools[3] then
			GLHITS=GLOCK_DBMiss+GLOCK_DBHits;
			GLOCK_temp1=GLhit;
			GLhit=GLOCK_sync_GLhit;
			GLOCK_DBMiti=100-((100-GLOCK_DBMiti)*(GLHITS-1)+(0-GLOCK_sync_gpenetration)/GLOCK_levelMiss(GLOCK_sync_Level))/GLHITS
			GLhit=GLOCK_temp1;
			GLOCK_DBMinR=GLOCK_DBMinR-(GLOCK_DBMinR-GLOCK_sync_gpenetration*4)*GLOCK_factor
		end

		MobResistDB[GLOCK_sync_dbindex]=string.format("%f/%d_%dA%f|%f",GLOCK_DBMiti,GLOCK_DBHits,GLOCK_DBMiss,GLOCK_DBMinR,GLOCK_DBi);
		if GLOCK_Target_Name==GLOCK_sync_Name then GLOCK_UpdateGUI() end;

		return
	end
	
	if GLOCK_sync_gpenetration==nil then return end

--Average Penetration, Average Hit%, Hit increment
	GLOCK_DBHits=GLOCK_DBHits+1;


--GLOCK_factor adapts as you get closer to the target (i.e. more samples available)
	if (GLOCK_DBHits)>GLCUSPS[1] then GLOCK_factor=GLFACTORS[1] end
	if (GLOCK_DBHits)>GLCUSPS[2] then GLOCK_factor=GLFACTORS[2] end
	if (GLOCK_DBHits)>GLCUSPS[3] then GLOCK_factor=GLFACTORS[3] end
	if (GLOCK_DBHits)>GLCUSPS[4] then GLOCK_factor=GLFACTORS[4] end
	if (GLOCK_DBHits)>GLCUSPS[5] then GLOCK_factor=GLFACTORS[5] end
	if (GLOCK_DBHits)>GLCUSPS[6] then GLOCK_factor=GLFACTORS[6] end
	if (GLOCK_DBHits)>GLCUSPS[7] then GLOCK_factor=GLFACTORS[7] end
	if (GLOCK_DBHits)>GLCUSPS[8] then GLOCK_factor=GLFACTORS[8] end

	GLOCK_DBi=(GLOCK_DBi*(GLOCK_DBHits+GLOCK_DBMiss-1)+(GLOCK_sync_GLhit))/(GLOCK_DBHits+GLOCK_DBMiss)
	GLOCK_DBMinR=GLOCK_DBMinR-(GLOCK_DBMinR-GLOCK_sync_gpenetration*4)*GLOCK_factor
	
--CALCULATE THE NEW RESIST VALUE
	if GLOCK_sync_school~=GLOCK_schools[3] then
		GLOCK_diff=(GLOCK_sync_gmitigated+GLOCK_sync_gpenetration-GLOCK_DBMiti)*GLOCK_factor;
		GLOCK_DBMiti=GLOCK_DBMiti + GLOCK_diff;
	end

--SPECIFIC CALCULATION FOR BINARY FROST SPELLS
	if GLOCK_sync_school==GLOCK_schools[3] then
		GLHITS=GLOCK_DBMiss+GLOCK_DBHits;
		GLOCK_temp1=GLhit;
		GLhit=GLOCK_sync_GLhit;
		GLOCK_DBMiti=100-((100-GLOCK_DBMiti)*(GLHITS-1)+(100-GLOCK_sync_gmitigated-GLOCK_sync_gpenetration)/GLOCK_levelMiss(GLOCK_sync_Level))/GLHITS
		GLhit=GLOCK_temp1;
	end

--STORE DATA
	MobResistDB[GLOCK_sync_dbindex]=string.format("%f/%d_%dA%f|%f",GLOCK_DBMiti,GLOCK_DBHits,GLOCK_DBMiss,GLOCK_DBMinR,GLOCK_DBi);

--UPDATE GUI
	GLOCK_sync_Name=gsub(GLOCK_sync_Name,"*","")
	if UnitName("Target")==GLOCK_sync_Name then GLOCK_UpdateGUI() end;
	
end

