--[[
	***********************************************

	GLOCK Localization

	***********************************************

]]

		GLOCK_schools={"Arcane","Fire","Frost","Nature","Shadow"};
		GLMAGE="mage"


	--THESE ARE THE ONLY SPELLS THIS MOD WILL RESPOND TO
		GLOCK_Arcane={"Arcane Explosion","Arcane Missile","Moonfire","Starfire"}
		GLOCK_Fire={"Hellfire","Immolate","Searing Pain","Conflagrate","Soul Fire","Fire Blast","Fireball","Pyroblast","Scorch"}
		GLOCK_Frost={"Frostbolt","Frost Shock"}
		GLOCK_Nature={"Wrath","Lightning Bolt","Chain Lightning"}
		GLOCK_Shadow={"Shadow Bolt","Mind Blast","Mind Flay","Mana Burn"}


	--FOR SET BONUSES
		GLARCANIST="Arcanist Regalia"
		GLZANZIL="Zanzil's Concentration"

	--SPECIFIC TEXT ON ITEMS
		GLEQUIP_PENETRATION="Equip: Decreases the magical resistances of your spell targets by "
		GLEQUIP_HIT="Equip: Improves your chance to hit with spells by "
		GLMAGE_ZGHIT="Spell Hit"

	--SPELL NAMES AND SPELL NAMES WITH RANK
		GL_COS="Curse of Shadow"
		GL_COE="Curse of the Elements"
		GL_COR="Curse of Recklessness"
		GL_TF="Thunderfury"
		
		GL_Weaving="Shadow Weaving"
		GL_impBolt="Shadow Vulnerability"

		GL_COSr="Curse of Shadow(rank 2)"
		GL_COEr="Curse of the Elements(rank 3)"
		GL_CORr="Curse of Recklessness(rank 4)"
		GL_COAr="Curse of Agony(rank 6)"

		GL_Eye="Obsidian Insight"  --This is the buff for the Eye of Moam
		GL_Qiraj="Mystical Disjunction" --Staff of the Qiraji Prophets

	--WAND STUFF	
		GLWANDACTION="Shoot"
		GL_WAND_TEXT={"Arcane Damage","Fire Damage","Frost Damage","Nature Damage","Shadow Damage"}


-------------------------
--This function parses the direct damage chat message
function GLOCK_DmgParse()


		if (GLOCK_Config["PVP"]==0 and UnitIsPlayer("Target")) then return end
		GLTempArg1=arg1;

	--Under several situations, resistance is not calculable
		if string.find(GLTempArg1,"is absorbed") then return end
		if string.find(GLTempArg1,"is reflected") then return end
		if string.find(GLTempArg1,"evade") then return end



	--This part drops from the calculation if target changes 
	--(note that this can't determine if you're targeting a new mob of the same name but a different level)	
		GLTName=UnitName("Target");
		if GLTName==nil then return end
		if string.find(GLTempArg1,GLTName)==nil then return end  --The user may change targets before the spell hits (fail)
		GLTempArg1=string.gsub(GLTempArg1,GLTName,"Target");
		if GLOCK_Target_Name==nil then return end

	--DETERMINE if it's one of our supported spells
		GLOCK_DecipherSchool(GLTempArg1)
		if GLOCK_cast_school==nil then return end
		gpenetration=(getglobal("GLD"..string.lower(GLOCK_cast_school))+GLnegresist)/4;
	
		GLOCK_dbindex=GLOCK_Target_Name.."/"..GLOCK_Target_Level.."/"..GLOCK_cast_school
	
	--respond to immunity
		if string.find(GLTempArg1,"immune") then 
			MobResistDB[GLOCK_dbindex.."immune"]=1;
			GLOCK_UpdateGUI()
			return
		elseif MobResistDB[GLOCK_dbindex.."immune"] then  MobResistDB[GLOCK_dbindex.."immune"]=nil
		end
	
	--EXTRACT DAMAGE DEALT
		i=string.find(GLTempArg1,"for")
		if i==nil then gdamage=0;
		else
			j=string.find(GLTempArg1," ",i+4);
			gdamage=tonumber(string.sub(GLTempArg1,i+4,j));
		end
	
	--EXTRACT DAMAGE RESISTED
		
		if (string.find(GLTempArg1,"resisted") and (not string.find(GLTempArg1,"was resisted"))) then
			i=string.find(GLTempArg1,"resisted")
			j=string.find(GLTempArg1," ",i-9)
			gresist=tonumber(string.sub(GLTempArg1,j+2,i-2))			 	
		else
			gresist=0;
		end
	
	--EXTRACT AMOUNT ABSORBED
		if string.find(GLTempArg1,"absorbed") then
			i=string.find(GLTempArg1,"absorbed"); j=string.find(GLTempArg1," ",i-9); gabsorbed=tonumber(string.sub(GLTempArg1,j+2,i-2))			 	
		else	gabsorbed=0; end
	
	--EXTRACT DAMAGE FROM VULNERABILITY BONUS (have not implemented a negative resist calculation yet)
		i=string.find(GLTempArg1,"vulnerability")
		if i==nil then gvuln=0;
		else
			j=string.find(GLTempArg1,"+",i-7)
			gvuln=tonumber(string.sub(GLTempArg1,j+1,i-2))
		end
	
	--TRACK VULNERABILITIES
		if gvuln>0 then
			MobResistDB[GLOCK_dbindex.."vuln"]=1;
			MobResistDB[GLOCK_dbindex]=nil;
			GLOCK_UpdateGUI()
			return
		end
		if MobResistDB[GLOCK_dbindex.."vuln"]==1 then return end
	
		if string.find(GLTempArg1,"was resisted") then gmitigated=100; gdamage=0 gresist=0
		else gmitigated=100*gresist/(gresist+gabsorbed+gdamage); end
	
		GLOCK_ResistCalc()  --Split the function here because different versions of this chat parse function need localization

end  --function
